#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <errno.h>

#include "../inc/udp_ctrl.h"

#define UCP4008_CTRL_PHYSADDR            0x82000000
#define PAGE_SIZE                        4096
#define SERVER_IP                        "172.29.118.76"
#define SERVER_PORT                      28864
#define BUFFER_SIZE                      1024

int main(int argc, char **argv) {

    msg_print("=== UCP4008_CTRL ===\n");

    int ucp_mem_fd;
    void *ucp4008_ctrl_mmap_base;
    volatile uint32_t *mapped_addr;
    ucp_mem_fd = open("/dev/mem", O_RDWR | O_SYNC);
    if (ucp_mem_fd == -1) {
      perror("[mmap]:open /dev/mem failed");
        return EXIT_FAILURE;
        exit(EXIT_FAILURE);
    }

    ucp4008_ctrl_mmap_base = mmap(
        NULL,
        PAGE_SIZE,
        PROT_READ | PROT_WRITE,
        MAP_SHARED,
        ucp_mem_fd,
        UCP4008_CTRL_PHYSADDR
    );

    if (ucp4008_ctrl_mmap_base == MAP_FAILED) {
      perror("[mmap]:mmap_base failed");
      close(ucp_mem_fd);
      exit(EXIT_FAILURE);
    }

    int sockfd_ctrl_ucp4008 = socket(AF_INET, SOCK_DGRAM, 0);
    if (sockfd_ctrl_ucp4008 < 0) {
      perror("[sockfd_ctrl_ucp4008]:socket creation failed\n");
      exit(EXIT_FAILURE);
    }

    struct sockaddr_in sockaddr_ctrl_ucp4008;
    memset(&sockaddr_ctrl_ucp4008, 0, sizeof(sockaddr_ctrl_ucp4008));
    sockaddr_ctrl_ucp4008.sin_family        =     AF_INET;
    sockaddr_ctrl_ucp4008.sin_port          =     htons(SERVER_PORT);
    sockaddr_ctrl_ucp4008.sin_addr.s_addr   =     inet_addr(SERVER_IP);

    char *message = "ready";
    sendto(sockfd_ctrl_ucp4008, message, strlen(message), 0,
           (struct sockaddr *)&sockaddr_ctrl_ucp4008, sizeof(sockaddr_ctrl_ucp4008));
    printf("[sendto]:%s\n", message);

    char buffer[BUFFER_SIZE];
    struct sockaddr_in from_addr;
    socklen_t from_addr_len = sizeof(from_addr);
    int recv_len = recvfrom(sockfd_ctrl_ucp4008, buffer, BUFFER_SIZE, 0,
                            (struct sockaddr *)&from_addr, &from_addr_len);
    if (recv_len < 0) {
      perror("[recvfrom]:recvfrom failed\n");
      close(sockfd_ctrl_ucp4008);
      exit(EXIT_FAILURE);
    }

    buffer[recv_len] = '\0';
    printf("[recvfrom]:%s\n", buffer);

    if (strcmp(buffer, "ok") == 0) {
        //TDDO
        usleep(1000000);
        printf("[mmap]:wr...\n");
        mapped_addr = (volatile uint32_t *)ucp4008_ctrl_mmap_base;
        *mapped_addr = 0xA5A55A5A;
        munmap(ucp4008_ctrl_mmap_base, PAGE_SIZE);
        close(sockfd_ctrl_ucp4008);
        close(ucp_mem_fd);
        msg_print("[0xA5A55A5A]: done :) \n");
        return EXIT_SUCCESS;
    } else {
        printf("[recvfrom]:recvfrom error\n");
        close(sockfd_ctrl_ucp4008);
        exit(EXIT_FAILURE);
    }
}